/// <reference types="react" />
import * as React from 'react';
import { ComponentClass } from 'react';
import { ObjectClean } from 'typelevel-ts';
import { PartialKeys } from '@devexperts/utils/lib/object/object';
import { TControlProps } from '../Control/Control';
export declare const CHECKBOX: symbol;
export declare type TFullCheckboxProps = TControlProps<boolean> & {
    id?: string;
    checkMark: React.ReactElement<any> | React.ReactText;
    isDisabled?: boolean;
    theme: {
        container?: string;
        container_isDisabled?: string;
        input?: string;
        view?: string;
        view_isDisabled?: string;
        icon?: string;
        icon_isChecked?: string;
        icon_isDisabled?: string;
    };
};
export declare type TCheckboxProps = ObjectClean<PartialKeys<TFullCheckboxProps, 'theme'>>;
export declare const Checkbox: ComponentClass<TCheckboxProps>;
