'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _storybook = require('@devexperts/tools/lib/utils/storybook');

var _Demo = require('../demo/Demo');

var _Dropdown = require('./Dropdown');

var _Button = require('../Button/Button');

var _pure = require('../../utils/pure');

var _Control = require('../Control/Control');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var StatefulDropdown = (0, _Control.stateful)('isOpened', 'onToggle')(_Dropdown.Dropdown);
var AnchorClass = function (_Component) {
    _inherits(AnchorClass, _Component);

    function AnchorClass() {
        _classCallCheck(this, AnchorClass);

        return _possibleConstructorReturn(this, (AnchorClass.__proto__ || Object.getPrototypeOf(AnchorClass)).apply(this, arguments));
    }

    _createClass(AnchorClass, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                innerRef = _props.innerRef,
                children = _props.children,
                onClick = _props.onClick;

            console.log('rendering anchor class');
            return React.createElement(_Button.Button, { ref: innerRef, onClick: onClick }, "Class Anchor", children);
        }
    }]);

    return AnchorClass;
}(_react.Component);
AnchorClass = tslib_1.__decorate([_pure.PURE], AnchorClass);
var AnchorSFC = function AnchorSFC(props) {
    var innerRef = props.innerRef,
        children = props.children,
        onClick = props.onClick;

    return React.createElement(_Button.Button, { ref: innerRef, onClick: onClick }, "SFC Anchor", children);
};
(0, _storybook.storiesOf)('Dropdown', module).add('with class Anchor', function () {
    return React.createElement(_Demo.Demo, null, React.createElement(StatefulDropdown, { Anchor: AnchorClass }, React.createElement("div", null, "hi!")));
}).add('with SFC Anchor', function () {
    return React.createElement(_Demo.Demo, null, React.createElement(StatefulDropdown, { Anchor: AnchorSFC, onToggle: console.log.bind(console) }, "hi"));
}).add('with force close', function () {
    return React.createElement(_Demo.Demo, null, React.createElement(DropdownPage, null));
});

var DropdownPage = function (_Component2) {
    _inherits(DropdownPage, _Component2);

    function DropdownPage() {
        _classCallCheck(this, DropdownPage);

        var _this2 = _possibleConstructorReturn(this, (DropdownPage.__proto__ || Object.getPrototypeOf(DropdownPage)).apply(this, arguments));

        _this2.onForceCloseClick = function () {
            _this2.forceClose();
        };
        _this2.getForceClose = function (close) {
            _this2.forceClose = close;
        };
        return _this2;
    }

    _createClass(DropdownPage, [{
        key: 'render',
        value: function render() {
            return React.createElement("div", null, React.createElement(StatefulDropdown, { Anchor: AnchorClass }, React.createElement(_Button.Button, { onClick: this.onForceCloseClick }, "Force close")));
        }
    }]);

    return DropdownPage;
}(_react.Component);