'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ResizeDetector = exports.RESIZE_DETECTOR = exports.NativeResizeDetector = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _pure = require('../../utils/pure');

var _withTheme = require('../../utils/withTheme');

var _elementResizeDetector = require('element-resize-detector');

var _elementResizeDetector2 = _interopRequireDefault(_elementResizeDetector);

var _raf = require('@devexperts/utils/lib/function/raf');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NativeResizeDetector = exports.NativeResizeDetector = (0, _elementResizeDetector2.default)({
    strategy: 'scroll'
});
var RESIZE_DETECTOR = exports.RESIZE_DETECTOR = Symbol('ResizeDetector');
var RawResizeDetector = function (_React$Component) {
    _inherits(RawResizeDetector, _React$Component);

    function RawResizeDetector() {
        _classCallCheck(this, RawResizeDetector);

        var _this = _possibleConstructorReturn(this, (RawResizeDetector.__proto__ || Object.getPrototypeOf(RawResizeDetector)).apply(this, arguments));

        _this.onResize = (0, _raf.raf)(function (element) {
            _this.props.onResize(element);
        });
        return _this;
    }

    _createClass(RawResizeDetector, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.element) {
                NativeResizeDetector.listenTo(this.element, this.onResize);
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (this.element) {
                NativeResizeDetector.uninstall(this.element);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var theme = this.props.theme;

            return React.createElement("div", { className: theme.container, ref: function ref(el) {
                    return _this2.element = el;
                } });
        }
    }]);

    return RawResizeDetector;
}(React.Component);
RawResizeDetector = tslib_1.__decorate([_pure.PURE], RawResizeDetector);
var ResizeDetector = exports.ResizeDetector = (0, _withTheme.withTheme)(RESIZE_DETECTOR)(RawResizeDetector);