'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RootClose = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _EventListener = require('../EventListener/EventListener');

var _reactDom = require('react-dom');

var _Control = require('../Control/Control');

var _pure = require('../../utils/pure');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RootClose = function (_Component) {
    _inherits(RootClose, _Component);

    function RootClose() {
        _classCallCheck(this, RootClose);

        var _this = _possibleConstructorReturn(this, (RootClose.__proto__ || Object.getPrototypeOf(RootClose)).apply(this, arguments));

        _this.preventMouseRootClose = false;
        _this.handleClickCapture = function (e) {
            _this.preventMouseRootClose = isModifiedEvent(e) || !isLeftClickEvent(e) || (0, _reactDom.findDOMNode)(_this).contains(e.target);
        };
        _this.handleClick = function (e) {
            if (!_this.props.ignoreClick && !_this.preventMouseRootClose && _this.props.onRootClose) {
                _this.props.onRootClose();
            }
        };
        _this.handleTouchStartCapture = function (e) {
            _this.preventMouseRootClose = (0, _reactDom.findDOMNode)(_this).contains(e.target);
        };
        _this.handleTouchStart = function () {
            if (!_this.props.ignoreClick && !_this.preventMouseRootClose && _this.props.onRootClose) {
                _this.props.onRootClose();
            }
        };
        _this.handleKeyUp = function (e) {
            if (!_this.props.ignoreKeyUp && e.keyCode === _Control.KeyCode.Escape && _this.props.onRootClose) {
                _this.props.onRootClose();
            }
        };
        return _this;
    }

    _createClass(RootClose, [{
        key: 'render',
        value: function render() {
            return React.createElement(_EventListener.EventListener, { target: document, onClick: this.handleClick, onClickCapture: this.handleClickCapture, onTouchStart: this.handleTouchStart, onTouchStartCapture: this.handleTouchStartCapture, onKeyUp: this.handleKeyUp }, this.props.children);
        }
    }]);

    return RootClose;
}(_react.Component);
exports.RootClose = RootClose = tslib_1.__decorate([_pure.PURE], RootClose);
exports.RootClose = RootClose;

function isLeftClickEvent(event) {
    return event.button === 0;
}
function isModifiedEvent(event) {
    return Boolean(event.metaKey || event.altKey || event.ctrlKey || event.shiftKey);
}