'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.TableCell = exports.TableRow = exports.TableHead = exports.TableBody = exports.Table = exports.RawTableHead = exports.TABLE = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _pure = require('../../utils/pure');

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _withTheme = require('../../utils/withTheme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TABLE = exports.TABLE = Symbol('Table');
var RawTable = function (_React$Component) {
    _inherits(RawTable, _React$Component);

    function RawTable() {
        _classCallCheck(this, RawTable);

        return _possibleConstructorReturn(this, (RawTable.__proto__ || Object.getPrototypeOf(RawTable)).apply(this, arguments));
    }

    _createClass(RawTable, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                theme = _props.theme,
                children = _props.children;

            return React.createElement("table", { className: theme.container }, children);
        }
    }]);

    return RawTable;
}(React.Component);
RawTable = tslib_1.__decorate([_pure.PURE], RawTable);
exports.default = RawTable;

var RawTableHead = function (_React$Component2) {
    _inherits(RawTableHead, _React$Component2);

    function RawTableHead() {
        _classCallCheck(this, RawTableHead);

        return _possibleConstructorReturn(this, (RawTableHead.__proto__ || Object.getPrototypeOf(RawTableHead)).apply(this, arguments));
    }

    _createClass(RawTableHead, [{
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                children = _props2.children,
                theme = _props2.theme;

            return React.createElement("thead", { className: theme.head }, React.Children.map(children, function (child) {
                return child && React.cloneElement(child, {
                    isInHead: true
                });
            }));
        }
    }]);

    return RawTableHead;
}(React.Component);
exports.RawTableHead = RawTableHead = tslib_1.__decorate([_pure.PURE], RawTableHead);
exports.RawTableHead = RawTableHead;

var RawTableBody = function (_React$Component3) {
    _inherits(RawTableBody, _React$Component3);

    function RawTableBody() {
        _classCallCheck(this, RawTableBody);

        return _possibleConstructorReturn(this, (RawTableBody.__proto__ || Object.getPrototypeOf(RawTableBody)).apply(this, arguments));
    }

    _createClass(RawTableBody, [{
        key: 'render',
        value: function render() {
            var _props3 = this.props,
                children = _props3.children,
                theme = _props3.theme;

            return React.createElement("tbody", { className: theme.body }, children);
        }
    }]);

    return RawTableBody;
}(React.Component);
RawTableBody = tslib_1.__decorate([_pure.PURE], RawTableBody);
var RawTableRow = function (_React$Component4) {
    _inherits(RawTableRow, _React$Component4);

    function RawTableRow() {
        _classCallCheck(this, RawTableRow);

        return _possibleConstructorReturn(this, (RawTableRow.__proto__ || Object.getPrototypeOf(RawTableRow)).apply(this, arguments));
    }

    _createClass(RawTableRow, [{
        key: 'render',
        value: function render() {
            var _props4 = this.props,
                children = _props4.children,
                theme = _props4.theme,
                onClick = _props4.onClick,
                onMouseOver = _props4.onMouseOver,
                onMouseOut = _props4.onMouseOut,
                isInHead = _props4.isInHead;

            return React.createElement("tr", { className: theme.row, onClick: onClick, onMouseOver: onMouseOver, onMouseOut: onMouseOut }, !isInHead && children, isInHead && React.Children.map(children, function (child) {
                return child && React.cloneElement(child, Object.assign({}, child.props, { isInHead: isInHead }));
            }));
        }
    }]);

    return RawTableRow;
}(React.Component);
RawTableRow = tslib_1.__decorate([_pure.PURE], RawTableRow);
var RawTableCell = function (_React$Component5) {
    _inherits(RawTableCell, _React$Component5);

    function RawTableCell() {
        _classCallCheck(this, RawTableCell);

        return _possibleConstructorReturn(this, (RawTableCell.__proto__ || Object.getPrototypeOf(RawTableCell)).apply(this, arguments));
    }

    _createClass(RawTableCell, [{
        key: 'render',
        value: function render() {
            var _props5 = this.props,
                children = _props5.children,
                theme = _props5.theme,
                style = _props5.style,
                colSpan = _props5.colSpan,
                rowSpan = _props5.rowSpan,
                isInHead = _props5.isInHead;

            var className = (0, _classnames3.default)(theme.cell, _defineProperty({}, theme.cell_isInHead, isInHead));
            //noinspection JSUnusedLocalSymbols
            var Tag = isInHead ? 'th' : 'td';
            return React.createElement(Tag, { className: className, style: style, colSpan: colSpan, rowSpan: rowSpan }, children);
        }
    }]);

    return RawTableCell;
}(React.Component);
RawTableCell = tslib_1.__decorate([_pure.PURE], RawTableCell);
var Table = exports.Table = (0, _withTheme.withTheme)(TABLE)(RawTable);
var TableBody = exports.TableBody = (0, _withTheme.withTheme)(TABLE)(RawTableBody);
var TableHead = exports.TableHead = (0, _withTheme.withTheme)(TABLE)(RawTableHead);
var TableRow = exports.TableRow = (0, _withTheme.withTheme)(TABLE)(RawTableRow);
var TableCell = exports.TableCell = (0, _withTheme.withTheme)(TABLE)(RawTableCell);